import re
import time

def index():
	return locals()
	

@cache(request.env.path_info, time_expire=10, cache_model=cache.ram)
@request.restful()
def status():
	if request.env.http_origin:
		response.headers['Access-Control-Allow-Origin'] = '*'

	def GET():
		res = {}
		t0 = time.time()
		for idx, config in enumerate(status_configs):
			adapter = status_adapters[idx]
			sensors = config.get('sensors')
			group = config.get('group')
			sensorlist = adapter.sensors
			data =  adapter.read_sensors(sensors, group)

			sensorname = config.get('server') + '__'
			sensorname += config.get('database') + '__'
			sensorname += config.get('group') + '__'
			
			for d, v in data[group].iteritems():
				if d is 'timestamp':
					s = sensorname + d
				else:
					try:
						s = sensorname + sensorlist.get(group).get(d)
					except:
						continue
				res[s] = v
		t1 = time.time()
		logger.debug(t1 - t0)
		return res


	return locals()
