/** @jsx React.Dom */

var React = require('react');
var ServerView = require('./server.jsx');

var data = [
{
    "server_name": "katrin",
    "groups": [ "group a", "group b", "group c" ]
},
{
    "server_name": "orca",
    "groups": [ "temp", "wall", "what ever" ]
}
];

var ServerNode = React.createClass({
    getInitialState: function() {
        return {
            visible: false
        };
    },
    render: function() {
        var groups = [];
        this.props.server.groups.map(function(item, index) {
            groups.push(<li>{item}</li>);
        });

        var style = {};
        if (!this.state.visible) {
            style.display = 'none';
        }

        return (
            <li onClick={this.toggle}> 
                {this.props.server.server_name}
                <ul style={style}>{groups}</ul>
            </li>
        );
    },
    toggle: function() {
        this.setState({visible: !this.state.visible});
    }
})

var TreeNode = React.createClass({
    render: function() {
        servers = [];
        this.props.servers.map(function(item, index) {
            servers.push(<ServerNode server={item}/>);
        });
        return (<ul>{servers}</ul>);
    }
});

function rendertree () {
    React.render(
            <TreeNode servers={data} />, 
            document.getElementById('server-list')
    );
}

/*
 *var ItemList = React.createClass({
 *     render: function() {
 *        var items = [];
 *        this.props.items.map(function(item) {
 *            items.push(<li>{item}</li>);
 *        });
 *        return <ul>{items}</ul>;
 *    }
 *});
 *
 *var ItemNode = React.createClass({
 *    render: function() {
 *        return (
 *            <li>{this.props.nodename}
 *                <ItemList items={this.props.items} />
 *            </li>
 *        );
 *    }
 *});
 */

var TreeItem = React.createClass({
    render: function() {
        return (<li>Item</li>);
    }
})

function render() {
    //React.render(
            //<ItemNode nodename="katrin" items={data.katrin} />, 
            //document.getElementById('server-list')
    //);
    //React.render(<NestedList />, document.getElementById('servers'));
}



////////////////////////////////////////////////////////////////////////////////
// test
var Hallo = React.createClass({
    render: function() {
        return <strong> Hallo {this.props.name} </strong>
    }
});

var Test = React.createClass({
    render: function() {
        this.props.data.forEach(function(node) {
            console.log(node, node.key);
        });
        return <p>Test</p>;
    }
});


function test() {
    //React.render(<Hallo name='Chuan'/>, document.getElementById('servers'));
    //React.render(<Test data={data}/>, document.getElementById('servers'));
    for (s in data) {
        console.log(s);
    }
}
////////////////////////////////////////////////////////////////////////////////

var app = {
    test: test,
    render: rendertree,
    data: data
};

module.exports = app;

